/* BFEncodingUtilities.h created by lindberg on Fri 28-Jan-2000 */

#import <Foundation/NSObjCRuntime.h>
//#import "FrameworkDefines.h"

@class NSString, NSData;

/*"
 * Functions to do Base-64 (RFC 1521) encoding and decoding of data.
 * 
 * BFBase64EncodeBytes() encodes the given bytes, returning the resulting
 * Base-64 buffer. The caller is responsible for NSZoneFree()ing the return
 * value. The size of the returned buffer is returned by reference in outLength.
 * If newlineString is non-NULL, then that string will be inserted for every 72
 * characters of Base-64 data generated. BFBase64EncodeData() and
 * BFBase64EncodeString() are variations to encode NSData or NSString values,
 * returning an autoreleased NSString object.
 * 
"*/
char     *BFBase64EncodeBytes(const char *bytes, int length, const char *newlineString, int *outLength);

NSString *BFBase64EncodeData(NSData *data, NSString *newlineString);
