/* TGenAdditions.h created by lindberg on Mon 20-Dec-1999 */

#import <Foundation/NSArray.h>
#import <Foundation/NSString.h>
#import <Foundation/NSData.h>


/* Various Foundation methods for use by templates and/or EOGenerator */
@interface NSObject (ClassTestMethods)
- (BOOL)isString;
- (BOOL)isData;
- (BOOL)isInteger;
- (BOOL)isReal;
- (BOOL)isArray;
- (BOOL)isDictionary;
@end


#ifdef NSFoundationVersionNumber10_0
#define COCOA 1

@interface NSArray (MiscKeyValue)
- (id)valueForKey:(NSString *)key;
    // When passed a "normal" key, returns an array composed of the
    // results of calling valueForKey: on all elements of the array.
    // When passed a key prefixed with "@" a single value is returned
    // which is the result of invoking an aggregate function on the values
    // of the array.
    // For instance, when passed @sum.budget, it will invoke -computeSumForKey:@"budget"
    // on the array.  The following aggregates are defined:
    //    @sum, @count, @avg, @min, @max
    // New methods added in categories on NSArray will automatically be detected
    // by the connection inspector in InterfaceBuilder.
        // "count" is a special key that will return the count, just like @count.

- (id)computeSumForKey:(NSString *)key;
- (id)computeAvgForKey:(NSString *)key;
- (id)computeCountForKey:(NSString *)key;
- (id)computeMaxForKey:(NSString *)key;
- (id)computeMinForKey:(NSString *)key;

@end
#endif


@interface NSArray (TGen)

- (NSArray *)sortedNumberArray;
- (id)computeSortedNumberArrayForKey:(NSString *)key;

@end


@interface NSData (Base64Encoding)

- (NSString *)base64String;

@end


@interface NSString (TGen)

+ (id)stringWithCStringNoCopy:(char *)bytes length:(unsigned)length;
+ (id)stringWithCStringNoCopy:(char *)bytes length:(unsigned)length freeWhenDone:(BOOL)freeBuffer;

@end
