/* EOTemplateGenerator.h created by mgentry on Mon 14-Jun-1999 */

#import <Foundation/Foundation.h>

@class MiscMergeTemplate;

typedef enum _ArgumentType {
    ArgumentInvalidOption = -1,
    ArgumentUnknownOption = 0,
    ArgumentVersion 	= 1,
    ArgumentHelp,
    ArgumentVerbose,
    ArgumentDelim,
    ArgumentStartDelim,
    ArgumentEndDelim,
    ArgumentRecursive,
    ArgumentForce,
    ArgumentTemplateDir,
    ArgumentTemplate,
    ArgumentInputFile,
    ArgumentOutputFile,
    ArgumentDefine
} ArgumentType;

@interface TemplateGenerator : NSObject
{
    // Templates - the primary class
    NSString *templateFile;
    NSString *inputFile;
    NSString *outputFile;

    NSString *delimStart;
    NSString *delimEnd;
    
    NSMutableArray *searchPaths;
    NSMutableDictionary *userVariables;

    BOOL verboseMode;
    BOOL forceOverwrites;
    BOOL recursiveLookups;
}

- init;
- (void)displayHelpAndExit:(int)exitStatus;
- (void)generate;

@end
